Split Hyprlock,Noctalia-Shell and Hyprpaper into separate directories. Made changes to ncli, to automatically switch specialisations. Started configuring niri.

This commit is contained in:
2025-11-25 14:30:53 +01:00
parent 157ba06453
commit 69d1d05563
26 changed files with 784 additions and 93 deletions

View File

@ -51,6 +51,9 @@
[
inputs.home-manager.nixosModules.home-manager
./hardware-configuration.nix
../plasma/plasma.nix
../hyprland/hyprland.nix
../niri/niri.nix
];
specialisation = {
@ -81,6 +84,14 @@
};
};
"niri" = {
configuration = {
imports = [
../niri/niri.nix
];
};
};
};
# Bootloader.
@ -95,7 +106,12 @@
#devices = [ "nodev" ];
efiSupport = true;
useOSProber = true;
#splashImage =
#splashImage =
extraConfig = ''
menuentry "NixOS - Default" {
set hidden=1
}
'';
};
@ -190,12 +206,29 @@
openssh.enable = true;
};
fonts.packages = with pkgs; [
font-awesome
nerd-fonts.jetbrains-mono
meslo-lgs-nf
];
fonts = {
packages = with pkgs; [
font-awesome
nerd-fonts.jetbrains-mono
meslo-lgs-nf
noto-fonts
noto-fonts-cjk-sans
noto-fonts-emoji
inter
];
fontconfig = {
enable = true;
defaultFonts = {
monospace = [ "JetBrainsMono Nerd Font" "MesloLGS NF" ];
sansSerif = [ "Inter" "Noto Sans" ];
serif = [ "Noto Serif" ];
};
};
};
#In order for dynamically linked executables to work
programs.nix-ld.enable = true;

View File

@ -1,11 +1,69 @@
{ ... }:
{ config, ... }:
{
imports = [
./configuration.nix
./firefox.nix
./boot-splash.nix
./zsh.nix
./neovim.nix
./packages.nix
#./configuration.nix
#./firefox.nix
#./boot-splash.nix
#./zsh.nix
#./neovim.nix
#./packages.nix
#./hardware-configuration.nix
./general.nix
../plasma/plasma.nix
../hyprland/hyprland.nix
../niri/niri.nix
];
specialisation = {
"plasma" = {
inheritParentConfig = false;
configuration = {
imports = [
../plasma/plasma.nix
./general.nix
];
programs.gamemode.enable = true;
environment.etc."nixos-tags".text = "plasma";
};
};
"hyprland" = {
inheritParentConfig = false;
configuration = {
imports = [
../hyprland/hyprland.nix
./general.nix
];
environment.etc."nixos-tags".text = "hyprland";
};
};
"minimal" = {
inheritParentConfig = false;
configuration = {
imports = [
./minimal.nix
];
environment.etc."nixos-tags".text = "minimal";
};
};
"niri" = {
inheritParentConfig = false;
configuration = {
imports = [
../niri/niri.nix
./general.nix
];
environment.etc."nixos-tags".text = "niri";
};
};
};
}

View File

@ -1,4 +1,4 @@
{ pkgs, ...}:
{ pkgs, username, ...}:
{
xdg = {
desktopEntries.youtube = {
@ -23,7 +23,7 @@
terminal = false;
categories = [ "System" "TerminalEmulator" ];
icon = "/etc/nixos/other/kitty.app.png";
icon = "/home/${username}/NixOS/other/kitty.app.png";
};
desktopEntries."org.kde.kinfocenter" = {

318
modules/general.nix Normal file
View File

@ -0,0 +1,318 @@
# Edit this configuration file to define what should be installed on
# your system. Help is available in the configuration.nix(5) man page
# and in the NixOS manual (accessible by running nixos-help).
#Access Internet using:
#nmcli device wifi list
#nmcli device wifi connect <ssid> password <password>
# or if no password (open wifi)
#nmcli device wifi connect <ssid>
#Nix flake file limit: ulimit -n 500000
{ inputs, config, pkgs, lib, username, host, version, system, grub2-theme, ... }:
{
stylix = {
enable = false;
image = ../other/wallpaper2.png;
#autoEnable = true; #Auto generate theme based on wallpaper
base16Scheme = "${pkgs.base16-schemes}/share/themes/tokyo-night-moon.yaml";
opacity = {
desktop = 0.5;
terminal = 0.9;
};
fonts = {
monospace = {
package = pkgs.nerd-fonts.jetbrains-mono;
name = "JetBrainsMono Nerd Font";
};
sansSerif = {
package = pkgs.inter;
name = "Inter";
};
serif = {
package = pkgs.noto-fonts;
name = "Noto Serif";
};
};
targets.grub.enable = false;
};
# in configuration.nix
#Assign Swap to the PC
#swapDevices = [{
# device = "/swapfile";
# size = 16 * 1024; # 16GB
#}];
imports =
[
inputs.home-manager.nixosModules.home-manager
inputs.grub2-themes.nixosModules.default
inputs.nix-flatpak.nixosModules.nix-flatpak
inputs.stylix.nixosModules.stylix
./hardware-configuration.nix
./firefox.nix
./boot-splash.nix
./zsh.nix
./neovim.nix
./packages.nix
];
# Bootloader.
boot.loader = {
systemd-boot.enable = false;
efi.canTouchEfiVariables = true;
#boot.loader.efi.efiSysMountPoint = "/boot/efi";
grub = {
enable = true;
device = "/dev/nvme0n1"; #Needs to be changed when using a new computer! (Make grub partition - look below!)
#devices = [ "nodev" ];
efiSupport = true;
useOSProber = true;
#splashImage =
# extraConfig = ''
# menuentry "NixOS - Default" {
# set hidden=1
# }
# '';
};
grub2-theme = {
enable = true;
theme = "whitesur";
footer = true;
};
timeout = 10;
};
#Ensure there is a grub_bios partition: (gparted)
#Create a new parititon. File System: Unformatted - Size: ~5 Mib
#Apply
#Manage flags -> Add bios_grub
networking.hostName = host;
# Define your hostname.
# networking.wireless.enable = true; # Enables wireless support via wpa_supplicant.
# Configure network proxy if necessary
# networking.proxy.default = "http://user:password@proxy:port/";
# networking.proxy.noProxy = "127.0.0.1,localhost,internal.domain";
home-manager = {
useGlobalPkgs = true;
useUserPackages = true;
users.${username} = ./home.nix;
backupFileExtension = "backup"; # Automatically backs up conflicting files during activation
extraSpecialArgs = { inherit inputs username version system host; };
sharedModules = [ inputs.plasma-manager.homeModules.plasma-manager ];
};
# Enable networking
networking.networkmanager.enable = true;
networking.extraHosts = ''
100.89.141.79 tail-rpi
'';
# Set your time zone.
time.timeZone = "Europe/Berlin";
# Select internationalisation properties.
i18n.defaultLocale = "en_US.UTF-8";
i18n.extraLocaleSettings = {
LC_ADDRESS = "de_DE.UTF-8";
LC_IDENTIFICATION = "de_DE.UTF-8";
LC_MEASUREMENT = "de_DE.UTF-8";
LC_MONETARY = "de_DE.UTF-8";
LC_NAME = "de_DE.UTF-8";
LC_NUMERIC = "de_DE.UTF-8";
LC_PAPER = "de_DE.UTF-8";
LC_TELEPHONE = "de_DE.UTF-8";
LC_TIME = "de_DE.UTF-8";
};
# List services that you want to enable:
services = {
ollama = {
enable = true;
# Optional: load models on startup
#loadModels = [ ... ];
};
fprintd.enable = true;
fprintd.tod.enable = true;
fprintd.tod.driver = pkgs.libfprint-2-tod1-goodix;
fwupd.enable = true; #Allows BIOS updates
locate = {
enable = true;
package = pkgs.plocate;
};
tailscale = {
enable = true;
useRoutingFeatures = "client";
extraSetFlags = [
"--operator=${username}"
"--accept-routes"
];
};
#Enable CUPS to print documents.
printing.enable = true;
# Enable the OpenSSH daemon.
openssh.enable = true;
};
fonts = {
packages = with pkgs; [
font-awesome
nerd-fonts.jetbrains-mono
meslo-lgs-nf
noto-fonts
noto-fonts-cjk-sans
noto-fonts-emoji
inter
];
fontconfig = {
enable = true;
defaultFonts = {
monospace = [ "JetBrainsMono Nerd Font" "MesloLGS NF" ];
sansSerif = [ "Inter" "Noto Sans" ];
serif = [ "Noto Serif" ];
};
};
};
#In order for dynamically linked executables to work
programs.nix-ld.enable = true;
programs.ssh.askPassword = lib.mkForce "${pkgs.kdePackages.ksshaskpass}/bin/ksshaskpass";
programs.steam.enable = true;
# Configure console keymap
console.keyMap = "de";
hardware.enableRedistributableFirmware = true;
#Enables proprietary, redistributable firmware so hardware devices function properly
hardware.graphics = {
enable = true;
# Mesa should be enabled by default for Vulkan, but you can be explicit
enable32Bit = true; # For 32-bit applications
};
hardware.cpu.amd.updateMicrocode = true;
hardware.bluetooth = {
enable = true;
powerOnBoot = true;
settings = {
General = {
# Shows battery charge of connected devices on supported
# Bluetooth adapters. Defaults to 'false'.
Experimental = true;
# When enabled other devices can connect faster to us, however
# the tradeoff is increased power consumption. Defaults to
# 'false'.
FastConnectable = true;
};
Policy = {
# Enable all controllers when they are found. This includes
# adapters present on start as well as adapters that are plugged
# in later on. Defaults to 'true'.
AutoEnable = true;
};
};
};
# security.rtkit.enable = true;
# services.pipewire = {
# enable = true;
# alsa.enable = true;
# alsa.support32Bit = true;
# pulse.enable = true;
# # If you want to use JACK applications, uncomment this
# #jack.enable = true;
#
# # use the example session manager (no others are packaged yet so this is enabled by default,
# # no need to redefine it in your config for now)
# #media-session.enable = true;
# };
# Enable touchpad support (enabled default in most desktopManager).
# services.xserver.libinput.enable = true;
# Define a user account. Don't forget to set a password with passwd.
users.users.${username} = {
isNormalUser = true;
description = "Cookiez";
extraGroups = [ "networkmanager" "wheel" "docker" ];
packages = with pkgs; [
#User Packages Here
];
};
virtualisation.docker.enable = true;
environment.etc."gitconfig".text = ''
[init]
defaultBranch = main
'';
#So no user in the group Wheel has to input the password in order to use sudo
security.sudo.wheelNeedsPassword = false;
#Allow Nix Commands
nix.settings.experimental-features = [ "nix-command" "flakes" ];
# Allow unfree packages
nixpkgs.config.allowUnfree = true;
# Some programs need SUID wrappers, can be configured further or are
# started in user sessions.
# programs.mtr.enable = true;
# programs.gnupg.agent = {
# enable = true;
# enableSSHSupport = true;
# };
environment.variables = {
EDITOR = "nvim";
# XKB_DEFAULT_LAYOUT = "de";
};
environment.sessionVariables = {
NIXOS_OZONE_WL = "1"; #For chromium to work under wayland and with virtual Keyboards (Only really needed for virtual keyboards, but doest hurt ...)
TERMINAL = "kitty";
};
# Open ports in the firewall.
# networking.firewall.allowedTCPPorts = [ ... ];
# networking.firewall.allowedUDPPorts = [ ... ];
# Or disable the firewall altogether.
# networking.firewall.enable = false;
# This value determines the NixOS release from which the default
# settings for stateful data, like file locations and database versions
# on your system were taken. Its perfectly fine and recommended to leave
# this value at the release version of the first install of this system.
# Before changing this value read the documentation for this option
# (e.g. man configuration.nix or on https://nixos.org/nixos/options.html).
system.stateVersion = version; # Did you read the comment?
}

View File

@ -0,0 +1,13 @@
{ config, inputs, pkgs, ... }:
{
imports = [
];
home-manager.sharedModules = [
./home.nix
];
environment.systemPackages = with pkgs;
[
];
}

10
modules/hyprlock/home.nix Normal file
View File

@ -0,0 +1,10 @@
{pkgs, inputs, username, ...}:
{
imports = [
];
programs = {
hyprlock.enable = true;
};
}

View File

@ -0,0 +1,13 @@
{ config, inputs, pkgs, ... }:
{
imports = [
];
home-manager.sharedModules = [
./home.nix
];
environment.systemPackages = with pkgs;
[
];
}

View File

@ -0,0 +1,22 @@
{pkgs, inputs, username, ...}:
{
imports = [
];
services = {
hyprpaper = {
enable = true;
settings = {
preload = [
"/home/${username}/NixOS/other/wallpaper2.png"
];
wallpaper = [
"eDP-1,/home/${username}/NixOS/other/wallpaper2.png"
];
};
};
};
}

View File

@ -127,8 +127,21 @@ in
handle_backups
echo "Starting NixOS rebuild for current host: $HOST"
cd "$HOME/$PROJECT" || { echo "Error: Could not change to $HOME/$PROJECT"; exit 1; }
current=""
if [ -f /etc/nixos-tags ]; then
current=$(cat /etc/nixos-tags)
fi
if sudo nixos-rebuild switch --flake ".#$HOST"; then
echo " Rebuild finished successfully for $HOST"
if [ -n "$current" ]; then
sudo /run/current-system/specialisation/$current/bin/switch-to-configuration switch
else
echo "No specialization tag found, staying on default system."
fi
else
echo " Rebuild failed for $HOST" >&2
exit 1
@ -147,9 +160,27 @@ in
exit 1
fi
echo "Rebuilding system..."
current=""
if [ -f /etc/nixos-tags ]; then
current=$(cat /etc/nixos-tags)
fi
if [ -n "$current" ]; then
echo "Rebuilding system... Current specialization: $current"
else
echo "Rebuilding system... Staying on current specialization"
fi
if sudo nixos-rebuild switch --flake ".#$HOST"; then
echo " Update and rebuild finished successfully for $HOST"
if [ -n "$current" ]; then
sudo /run/current-system/specialisation/$current/bin/switch-to-configuration switch
else
echo "No specialization tag found, staying on default system."
fi
else
echo " Update and rebuild failed for $HOST" >&2
exit 1

View File

@ -0,0 +1,14 @@
{ config, inputs, pkgs, ... }:
{
imports = [
];
home-manager.sharedModules = [
./home.nix
];
environment.systemPackages = with pkgs;
[
inputs.noctalia.packages.${system}.default
];
}

13
modules/noctalia/home.nix Normal file
View File

@ -0,0 +1,13 @@
{pkgs, inputs, ...}:
{
imports = [
inputs.noctalia.homeModules.default
];
programs = {
noctalia-shell = {
enable = true;
systemd.enable = true;
};
};
}

View File

@ -1,7 +1,7 @@
{config, pkgs, libs, inputs, nix-flatpak, ...}:
{
environment.systemPackages = with pkgs; [
#Essenteals (CLI Only)
#Essentials (CLI Only)
wget #A tool for quickly downloading things from the Web
micro-with-xclip #Micro text editor with xclip for clipboard
thefuck #Error correction in case commands are wrong. Type: 'fuck'
@ -47,6 +47,11 @@
vscode #Editor for all kinds of programms
nodejs_22
#Hochschule
postgresql
dbeaver-bin
sqlite
#Desktop Applications
ryubing
vlc
@ -79,6 +84,8 @@
kdePackages.dolphin
persepolis #Download Manager
libreoffice-still
kdePackages.kservice
qbittorrent
#CLI tools
pdftk
@ -92,6 +99,8 @@
texliveFull #LaTeX PDF maker
lazygit
gtypist
powertop
file
];
nixpkgs.config.permittedInsecurePackages = [

View File

@ -1,4 +1,4 @@
{ config, pkgs, ... }: {
{ config, pkgs, username, ... }: {
programs.zsh = {
enable = true;
@ -8,7 +8,7 @@
};
shellInit = ''
source /etc/nixos/other/aliases
source /home/${username}/NixOS/other/aliases
'';
#To reset powerlevel10k, write 'p10k configure' in shell!